package com.example.wholeestate.controller;


import com.example.wholeestate.common.base.BaseController;
import com.example.wholeestate.common.resp.ResponseBean;
import com.example.wholeestate.dao.SysUserMapper;
import com.example.wholeestate.model.SysUser;
import com.example.wholeestate.service.ISysUserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpSession;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author weiximei
 * @since 2019-03-20
 */
@RestController
@RequestMapping("/")
@Api(value = "后端用户 API", description = "后端用户 API")
public class SysUserController extends BaseController {

    @Autowired
    private ISysUserService iSysUserService;

    @RequestMapping(value = "/user/login", method = RequestMethod.POST)
    @ApiOperation(value = "登陆", notes = "登陆")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "body", dataTypeClass = String.class, name = "parameter", value = "userName用户名;password密码")
    })
    public ResponseBean login(HttpSession session, @RequestBody String parameter) {
        ResponseBean responseBean = new ResponseBean();
        responseBean = iSysUserService.login(parameter);
        SysUser sysUser = (SysUser) responseBean.getData();
        setSessionUser(session, sysUser);
        return responseBean;
    }

    @RequestMapping(value = "/user/loginOut", method = RequestMethod.GET)
    @ApiOperation(value = "退出登陆", notes = "退出登陆")
    public ResponseBean loginOut(HttpSession session) {
        ResponseBean responseBean = new ResponseBean();
        removeSessionUser(session);
        responseBean.addSuccess("退出登陆成功!");
        return responseBean;
    }

    @RequestMapping(value = "/user/info", method = RequestMethod.GET)
    @ApiOperation(value = "获取登陆的用户信息", notes = "获取登陆的用户信息")
    public ResponseBean loginInfo(HttpSession session) {
        ResponseBean responseBean = new ResponseBean();
        SysUser sessionUser = getSessionUser(session);
        responseBean.addSuccess(sessionUser);
        return responseBean;
    }

}
