package com.example.wholeestate.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.example.wholeestate.common.resp.ResponseBean;
import com.example.wholeestate.model.TaCollection;

/**
 * <p>
 * 收藏表 服务类
 * </p>
 *
 * @author weiximei
 * @since 2019-03-21
 */
public interface ITaCollectionService extends IService<TaCollection> {

    /**
     * 根据 openid 查询 收藏楼盘记录
     * @param openid
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseBean openidCollectionBuilding(String openid, Integer pageNum, Integer pageSize);

    /**
     * 根据 openid 和 楼盘id 删除收藏列表
     * @param openid
     * @param buildingId
     * @return
     */
    ResponseBean deleteCollection(String openid, String buildingId);

    /**
     * 根据 openid 和 楼盘id 添加收藏列表
     * @param openid
     * @param buildingId
     * @return
     */
    ResponseBean addCollection(String openid, String buildingId);

}
